#pipeline to generate & parse slim sims based on refSeq gene structure

#'''Add your own working directories here'''
cd /gpfs/group/mxd60/default/VolcanoFinder/Simulations/
path='/gpfs/group/mxd60/default/VolcanoFinder/Simulations/'
SLIM='/gpfs/group/mxd60/default/sw/SLiM3.3/slim'

#rep=$1
seeds=flank500kb_refSeq_HC_bgSel/refSeq_HC_bgSel_seeds.txt
#slimout=$1
#parsedS=$2
#parsedR=$3
#seeds=$4

#get the number of lines of Tx list
#range=$( zcat hg19_geneTx_NCBI_RefSeq_UCSC2019May.txt.gz | wc -l )
range=61178

if [ $1 == 0 ]; then echo -e 'rep\tlineno\tseed' > $seeds ; fi

for rep in $( seq $1 $2  ); do
    #define files
    slimout=flank500kb_refSeq_HC_bgSel/slimout/flank500kb_refSeq_HC_bgSel_${rep}_slim.vcf
    slimout2=flank500kb_refSeq_HC_nobgSel/slimout/flank500kb_refSeq_HC_nobgSel_${rep}_slim.vcf
    parsedS=flank500kb_refSeq_HC_bgSel/input/flank500kb_refSeq_HC_bgSel_${rep}_SNP.txt
    parsedR=flank500kb_refSeq_HC_bgSel/input/flank500kb_refSeq_HC_bgSel_${rep}_Rec.txt
    parsedS2=flank500kb_refSeq_HC_nobgSel/input/flank500kb_refSeq_HC_nobgSel_${rep}_SNP.txt
    parsedR2=flank500kb_refSeq_HC_nobgSel/input/flank500kb_refSeq_HC_nobgSel_${rep}_Rec.txt
	#generate random #
	lineno=$(( $RANDOM%$range ))
	#echo $lineno
	#grep the line
	line=$( zcat hg19_geneTx_NCBI_RefSeq_UCSC2019May.txt.gz | head -$lineno | tail -1 | cut -f 5,6,10,11 )
	#echo $line 
	start=$( echo $line | awk 'BEGIN{FS=" "}{print $1}' )
	length=$( echo $line | awk 'BEGIN{FS=" "}{print $2 - $1 + 1}' )
    End=$( echo $( expr $length + 1001000 - 1 ) )
	echo 'Gene length='$length
	utrStarts=$( echo -e "UTRstarts=c(500000,"$(expr $length + 500200 )")" )
	utrEnds=$( echo -e "UTRends=c(500199,"$(expr $length - 1 + 500200 + 800 )")" )
	bgStarts=$(echo -e "starts=c(0,"$( expr $length + 500200 + 800)")")
	bgEnds=$( echo -e "ends=c(499999,"$(expr $length + 1000200 + 799)")" )
	exStarts=$( echo $line | awk -v s=$start 'BEGIN{FS=" "; printf("exonStarts=c("); OFS="," }{
		N=split($3,exons,","); 
		for(p=1;p<N;p++){
			if(p<N-1){ printf(exons[p] - s + 500200",")
			}else if(p==N-1){printf(exons[p] - s+ 500200)}
		}
	}END{printf(")")}' )
	exEnds=$(echo $line | awk -v s=$start 'BEGIN{FS=" "; printf("exonEnds=c("); OFS="," }{
		N=split($4,exons,","); 
		for(p=1;p<N;p++){
			if(p<N-1){ printf(exons[p] - s + 500200",")
			}else if(p==N-1){printf(exons[p] - s+ 500200)}
		}
	}END{printf(")")}')
	intrStarts=$(echo $line | awk -v s=$start 'BEGIN{FS=" "; printf("intronStarts=c("); OFS="," }{
		N=split($4,exons,","); 
		for(p=1;p<N;p++){
			if(p<N-2){ printf(exons[p] - s + 500201",")
			}else if(p==N-2){printf(exons[p] - s+ 500201)}
		}
	}END{printf(")")}')
	intrEnds=$(echo $line | awk -v s=$start 'BEGIN{FS=" "; printf("intronEnds=c("); OFS="," }{
		N=split($3,exons,","); 
		for(p=2;p<N;p++){
			if(p<N-1){ printf(exons[p] - s + 500199",")
			}else if(p==N-1){printf(exons[p] - s+ 500199)}
		}
	}END{printf(")")}')
echo background starts $bgStarts, beckground ends $bgEnds
echo utr starts at $utrStarts, utr ends at $utrEnds
echo exons starts at $exStarts, ends at $exEnds
echo introns starts at $intrStarts, introns ends at $intrEnds
	#run slim
	sd=$RANDOM
	echo running slim
	#-d $bgStarts -d $bgEnds -d $utrStarts -d $utrEnds -d $exStarts -d $exEnds -d $intrStarts -d $intrEnds
    /gpfs/group/mxd60/default/sw/SLiM3.3/slim -time -seed $sd -d $bgStarts -d $bgEnds -d $utrStarts -d $utrEnds -d $exStarts -d $exEnds -d $intrStarts -d $intrEnds Slim3_RefSeq_HC_bgSel.eidos > $slimout
    #echo /gpfs/group/mxd60/default/sw/SLiM3.3/slim -time -seed $sd -d end=$End Slim3_RefSeq_HC_nobgSel.eidos 
	/gpfs/group/mxd60/default/sw/SLiM3.3/slim -time -seed $sd -d end=$End Slim3_RefSeq_HC_nobgSel.eidos > $slimout2
	#$args
	#head $slimout
    wc -l $slimout
	wc -l $slimout2
	#record seeds
	echo -e ${rep}"\t"${lineno}"\t"${sd} >> $seeds

	#parse
	outseq=60
	cat $slimout | awk -v O=$outseq 'BEGIN{
		OFS="\t";
		print "position","x","n"
	}{
		if($9 =="GT" && $5 ~ /^[A|T|C|G]$/ && $4 != $5 ){  
			pos=$2
			split($O,g,"|"); anc = g[1]
			drv=0 ; total=0
			for(x=10;x<O;x++){
				split($x,h,"|")
				if(h[1] != anc) drv++ ;
				if(h[2] != anc) drv++ ;
				total = total + 2
			}
			print pos,drv,total
		}
	}' > $parsedS

    cat $slimout2 | awk -v O=$outseq 'BEGIN{
        OFS="\t";
        print "position","x","n"
    }{
        if($9 =="GT" && $5 ~ /^[A|T|C|G]$/ && $4 != $5 ){  
            pos=$2
            split($O,g,"|"); anc = g[1]
            drv=0 ; total=0
            for(x=10;x<O;x++){
                split($x,h,"|")
                if(h[1] != anc) drv++ ;
                if(h[2] != anc) drv++ ;
                total = total + 2
            }
            print pos,drv,total
        }
    }' > $parsedS2

	cat $parsedS | awk 'BEGIN{
		OFS="\t";
		print "position","rate"
	}{
		if(NR==2){
			print $1, 0
			lastpos=$1
		}else if(NR>2){
			dist=$1-lastpos
			print $1, dist*1e-6
			lastpos=$1
		}
	}' > $parsedR

    cat $parsedS2 | awk 'BEGIN{
        OFS="\t";
        print "position","rate"
    }{
        if(NR==2){
            print $1, 0
            lastpos=$1
        }else if(NR>2){
            dist=$1-lastpos
            print $1, dist*1e-6
            lastpos=$1
        }
    }' > $parsedR2

    wc -l $parsedR
    wc -l $parsedS
    wc -l $parsedR2
    wc -l $parsedS2
done	

echo $(date)

